## reposurgeon 4.24

=== Makefile ===
#
# makefile for reposurgeon
#
INSTALL=install
prefix?=/usr/local
mandir?=share/man
target=$(DESTDIR)$(prefix)

META = README.adoc INSTALL.adoc NEWS.adoc COPYING
PAGES = reposurgeon.adoc repocutter.adoc repomapper.adoc repotool.adoc repobench.adoc
DOCS = $(PAGES) repository-editing.adoc oops.svg
SOURCES = $(shell ls */*.go) repobench reposurgeon-mode.el go.mod go.sum extractversion.sh
SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
SOURCES += Dockerfile ci/prepare.sh .gitlab-ci.yml
SOURCES += $(META) $(DOCS)

.PHONY: all build install uninstall version check release refresh \
	docker-build docker-check docker-check-noscm get test fmt lint

BINARIES  = reposurgeon repotool repomapper repocutter
INSTALLABLES = $(BINARIES) repobench
MANPAGES  = $(PAGES:.adoc=.1)
HTMLFILES = $(DOCS:.adoc=.html)
SHARED    = $(META) reposurgeon-git-aliases $(HTMLFILES)

.PHONY: all fullinstall build stable-golang current-golang helpers test-helpers \
		get test lint fmt clean install uninstall dist release refresh

# Binaries need to be built before generated documentation parts can be made.
all: build $(MANPAGES) $(HTMLFILES)

# The following would produce reproducible builds, but it breaks Gitlab CI.
#GOFLAGS=-gcflags 'all=-N -l -trimpath $(GOPATH)/src' -asmflags 'all=-trimpath $(GOPATH)/src'
build: surgeon/help-index.go
	sh extractversion.sh -g <NEWS.adoc >surgeon/version.go
	go build $(GOFLAGS) -o repocutter ./cutter
	go build $(GOFLAGS) -o repomapper ./mapper
	go build $(GOFLAGS) -o reposurgeon ./surgeon
	go build $(GOFLAGS) -o repotool ./tool

reposurgeon: build

#
# Fast installation in apt-world. Fire either stable-golang or current-golang,
# then helpers, then test-helpers if you want to run the test suite,
#
fullinstall: stable-golang helpers test-helpers

stable-golang:
	sudo apt install golang

# This may improve performance, if the backports repostotory
# has been updated to a version more recemnt than your distro's.
current-golang:
	sudo add-apt-repository ppa:longsleep/golang-backports
	sudo apt update
	sudo apt install golang-go
	go version

helpers:
	sudo apt-get install asciidoctor cvs-fast-export subversion cvs mercurial hg-git-fast-import rsync

test-helpers: 
	sudo apt install golint shellcheck

#
# Documentation
#

# Note: to suppress the footers with timestamps being generated in HTML,
# we use "-a nofooter".
# To debug asciidoc problems, you may need to run "xmllint --nonet --noout --valid"
# on the intermediate XML that throws an error.
.SUFFIXES: .html .adoc .1

.adoc.1:
	asciidoctor -D. -a nofooter -b manpage $<
.adoc.html:
	asciidoctor -D. -a webfonts! $<

# This is a list of help topics for which the help is in regular format
# and there is no additional material included in the long-form mnual only.
# This means there's one line of BNF, a blank separator line, and one or
# more blank-line-separated paragraphs of running text.
BNF_TOPICS = \
	add \
	append \
	authors \
	assign \
	bench \
	blob \
	branch \
	branchlift \
	changelogs \
	checkout \
	choose \
	clear \
	coalesce \
	count \
	debranch \
	dedup \
	define \
	delete \
	diff \
	divide \
	do \
	drop \
	elapsed \
	exit \
	expunge \
	filter \
	gc \
	gitify \
	graft \
	graph \
	hash \
	help \
	history \
	ignores \
	incorporate \
	index \
	inspect \
	legacy \
	lint \
	list \
	log \
	logfile \
	manifest \
	memory \
	merge \
	msgin \
	msgout \
	names \
	path \
	prefer \
	preserve \
	print \
	quit \
	readlimit \
	rebuild \
	references \
	remove \
	rename \
	renumber \
	reorder \
	reset \
	resolve \
	script \
	set \
	setfield \
	setperm \
	shell \
	sizeof \
	sizes \
	sourcetype \
	split \
	stamp \
	stats \
	strip \
	tag \
	tagify \
	tags \
	timeoffset \
	timequake \
	timing \
	tip \
	transcode \
	unassign \
	undefine \
	unite \
	unmerge \
	unpreserve \
	version \
	when
UNANCHORED_TOPICS = \
	functions \
	options \
	redirection \
	regexp
READ_OPTION_TOPICS = \
	branchify
TOPICS = $(BNF_TOPICS) $(UNANCHORED_TOPICS) $(READ_OPTION_TOPICS)
# These are in regular form, but the entries in the
# long-form manual have additional material.
SHORTFORM = \
	read \
	squash \
	write
# These are all the non-regular topics
EXCEPTIONS = \
	attribution \
	lint \
	profile \
	reparent \
	selection \
	syntax

# Most othe command descriptions in Repositpory editing are reposurgeon's embedded
# help, lightly massaged into asciidoc format.
repository-editing.html: surgeon/reposurgeon.go reposurgeon repository-editing.adoc
	@rm -fr docinclude; mkdir docinclude
	@get_help() { \
		./reposurgeon "set asciidoc" "help $${1}" | \
			sed -e 's/help regexp/<<regular_expressions,help regexp>>/g' \
			    -e 's/help read/<<read_cmd,help read>>/g' \
			    -e 's/help branchify/<<branchify_opt,help branchify>>/g' \
			    -e 's/#/+#+/'; \
	}; \
	for topic in $(BNF_TOPICS); \
	do \
		echo "[[$${topic}_cmd,$${topic}]]" >>"docinclude/$${topic}.adoc"; \
		get_help "$${topic}" >>"docinclude/$${topic}.adoc"; \
	done; \
	for topic in $(UNANCHORED_TOPICS); \
	do \
		get_help "$${topic}" >>"docinclude/$${topic}.adoc"; \
	done; \
	for topic in $(READ_OPTION_TOPICS); \
	do \
		echo "[[$${topic}_opt,--$${topic}]]" >>"docinclude/$${topic}.adoc"; \
		get_help "$${topic}" >>"docinclude/$${topic}.adoc"; \
	done
	@./reposurgeon "help options" | sed '/:/s//::/' >docinclude/options.adoc
	@./repository-editing.rb

# Audit for embedded-help entries not used as inclusions (column 1)
# or inclusions for which there are no corresponding help topics (column 2).
# Column 2 should always be empty.
helpcheck:
	@(for topic in $(TOPICS); do echo $${topic}; done) | sort >/tmp/topics$$$$; \
	sed -n <repository-editing.adoc '/include::docinclude\/\([a-z]*\).adoc\[\]/s//\1/p' | sort >/tmp/includes$$$$ ; \
	comm -3 /tmp/topics$$$$ /tmp/includes$$$$; \
	rm /tmp/topics$$$$ /tmp/includes$$$$

# Report most grammar summary lines. Missing: the SHORTFORM and EXCEPTION topics.
summary:
	@for topic in $(BNF_TOPICS); do head -2 "docinclude/$${topic}.adoc"; done | grep -v '^\[\[' | sed '/::$$/s///'

surgeon/help-index.go: help-index.awk repository-editing.adoc
	awk -f $^ >$@

#
# Auxillary Go tooling productions
#

get:
	go get -u ./...	# go get -u=patch for patch releases

test:
	go test $(TESTOPTS) ./surgeon
	go test $(TESTOPTS) ./cutter

lint:
	golint -set_exit_status ./...
	shellcheck -f gcc extractversion.sh repobench test/fi-to-fi test/liftcheck test/singlelift test/svn-to-git test/svn-to-svn test/delver test/*.sh test/*test

fmt:
	gofmt -w .

#
# Cleaning
#
clean:
	rm -f $(BINARIES) surgeon/version.go
	rm -fr docinclude *~ *.1 *.html *.tar.xz MANIFEST *.md5
	rm -fr .rs .rs* test/.rs test/.rs*
	rm -f typescript test/typescript

#
# Installation
#
# Note that this does not run a build, so it will error out (harmlessly) if you 
# have not done "make all" or "make build" first.  There's a conflict between
# Go's preference for Rebuilding All The Things and the traditional makefile
# attempt to do as little build work as possible at any given time.
#
install:
	$(INSTALL) -d "$(target)/bin"
	$(INSTALL) -d "$(target)/share/doc/reposurgeon"
	$(INSTALL) -d "$(target)/$(mandir)/man1"
	$(INSTALL) -m 755 $(INSTALLABLES) "$(target)/bin"
	$(INSTALL) -m 644 $(SHARED) "$(target)/share/doc/reposurgeon"
	$(INSTALL) -m 644 $(MANPAGES) "$(target)/$(mandir)/man1"

#
# Uninstallation
#

INSTALLED_BINARIES := $(INSTALLABLES:%="$(target)/bin/%")
INSTALLED_SHARED   := $(SHARED:%="$(target)/share/doc/reposurgeon/%")
INSTALLED_MANPAGES := $(MANPAGES:%="$(target)/$(mandir)/man1/%")

uninstall:
	rm -f $(INSTALLED_BINARIES)
	rm -f $(INSTALLED_MANPAGES)
	rm -f $(INSTALLED_SHARED)
	rmdir "$(target)/share/doc/reposurgeon"

VERS=$(shell sh ./extractversion.sh <NEWS.adoc)

version:
	@echo $(VERS)

#
# Code validation
#

check: lint build test
	$(MAKE) -C test --quiet check BINDIR=$(realpath $(CURDIR))

fixme:
	@if command -v rg; then \
		rg FIXME; \
	else \
		find . -type f -exec grep -n FIXME {} /dev/null \; | grep -v "[.]git"; \
	fi

#
# Continuous integration.  More specifics are in the ci/ directory
#

docker-build: $(SOURCES)
	docker build -t reposurgeon .

docker-check: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon make check

docker-check-only-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-only-$(*) && make check"

docker-check-no-%: docker-build
	docker run --rm -i -e "MAKEFLAGS=$(MAKEFLAGS)" -e "MAKEOVERRIDES=$(MAKEOVERRIDES)" reposurgeon bash -c "make -C ci install-no-$(*) && make check"

# Test that support for each VCS stands on its own and test without legacy
# VCS installed
docker-check-noscm: docker-check-only-bzr docker-check-only-cvs \
    docker-check-only-git docker-check-only-mercurial \
    docker-check-only-subversion docker-check-no-cvs 
# Due to many tests depending on git, docker-check-only-mercurial is a very poor
# test of Mercurial

#
# Release shipping.
#

# Don't try using tar --transform, it tries to get too clever with symlinks 
reposurgeon-$(VERS).tar.xz: $(SHIPPABLE)
	(git ls-files; ls *.1) | sed s:^:reposurgeon-$(VERS)/: >MANIFEST
	(cd ..; ln -s reposurgeon reposurgeon-$(VERS))
	(cd ..; tar -cJf reposurgeon/reposurgeon-$(VERS).tar.xz `cat reposurgeon/MANIFEST`)
	(cd ..; rm reposurgeon-$(VERS) reposurgeon/MANIFEST)

dist: reposurgeon-$(VERS).tar.xz

reposurgeon-$(VERS).md5: reposurgeon-$(VERS).tar.xz
	@md5sum reposurgeon-$(VERS).tar.xz >reposurgeon-$(VERS).md5

release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 $(HTMLFILES)
	shipper version=$(VERS) | sh -e -x

refresh: $(HTMLFILES)
	shipper -N -w version=$(VERS) | sh -e -x

# end

=== test/Makefile ===
# Test-suite makefile for reposurgeon

# By setting the REPOSURGEON environment variable and using -e
# a different implementation can be plugged in to the tests.

# Use absolute path so tests that change working directory still use 
# scripts from parent directory.  Note that using $PWD seems to fail
# here under Gitlab's CI environment.
PATH := $(BINDIR):$(realpath ..):$(realpath .):${PATH}
REPOSURGEON := reposurgeon 
REPOCUTTER := repocutter 
REPOTOOL := repotool
REPOMAPPER := repomapper

# Force the timezone in case CI has a different idea
export TZ=UTC

# Setting this to 0 allows tests to continue on error.
STOPOUT=1

# Setting this to 1 suppresses diffs in favor of a FAIL tag
QUIET=0

# Force pure serial execution when rebuilding check files.  Slower,
# but makes them deterministic and may help smoke out bugs in
# concurrent code.
BUILDOPT="set serial"

# Defeat annoying behavior under Mac OS X - builtin echo doesn't do -n
ECHO := /bin/echo

# Define test groups
BASIC = listcheck roundtrip roundtrip-compress messagebox fi-regress
SUBVERSION = svnload-regress liftcheck-regress legacy-regress svncheck-regress
FULLSUBVERSION = $(SUBVERSION) liftcheck-fullregress
GIT_EXTRACTOR = git-regress git-regress-branches git-regress-merges git-regress-tags
HG_EXTRACTOR = hg-regress hg-regress-branches hg-regress-merges hg-regress-tags \
	hg-regress-patho
AUXTOOLS = repocutter-regress repomapper-regress repotool-regress

# See https://stackoverflow.com/questions/6481005/how-to-obtain-the-number-of-cpus-cores-in-linux-from-the-command-line
CONCURRENT_JOBS=$(shell getconf _NPROCESSORS_ONLN || getconf NPROCESSORS_ONLN || echo 4)

# Exploit make parallelism
PARALLEL_MAKE=$(MAKE) --output-sync --no-print-directory -j $(CONCURRENT_JOBS)

# check-aux must not be run in parallel.
check:
	$(MAKE) -j1 check-aux

# This should always be a full test
check-aux: clean disclose $(BASIC) $(FULLSUBVERSION) $(GIT_EXTRACTOR) $(HG_EXTRACTOR) $(AUXTOOLS) sporadic
	@echo "=== No diff output is good news ==="

disclose:
	@echo "Running with $(CONCURRENT_JOBS) threads."

# FIXME: is log -all really correct when regenerating the map checks?

.SUFFIXES: .svn .chk .fi .map

.svn.chk:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@ 2>&1
.svn.fi:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@
.svn.map:
	$(REPOSURGEON) "log -all" "read <$<" "legacy write -" >$@

buildregress: fi-buildregress svnload-buildregress legacy-buildregress \
	repomapper-buildregress repotool-buildregress hg-buildregress-branches \
	svncheck-buildregress repocutter-buildregress repomapper-buildregress \
	repotool-buildregress

clean:
	rm -fr .rs* test-repo test-checkout git-repo left-repo right-repo *~

options:
	@echo "REPOSURGEON is '$(REPOSURGEON)'"
	@echo "TESTOPT is '$(TESTOPT)'"

# Show summary lines for all tests.
testlist:
	@grep --text '^##' *.tst *.sh
	@grep --text '^ ##' *.svn
listcheck:
	@for f in *.tst *.svn; do \
	    if ( head -3 $$f | grep --text -q '^ *##' ); then :; else echo "$$f needs a description" >&2; exit $(STOPOUT); fi;  \
	done

# Test that all stream files round-trip properly
RULES_ROUNDTRIP=$(patsubst %,roundtrip-%,$(wildcard *.fi))
roundtrip:
	@echo "=== Testing stream-file round-tripping:"
	@$(PARALLEL_MAKE) $(RULES_ROUNDTRIP)

$(RULES_ROUNDTRIP): roundtrip-%: %
	@echo "  $<"; \
	$(REPOSURGEON) "$(TESTOPT)" "read -;write -" <$< >/tmp/rs$$$$ || exit $(STOPOUT); \
	[ -s /tmp/rs$$$$ ] && diff --text -u $< /tmp/rs$$$$ \
		|| exit $(STOPOUT); \
	rm -f /tmp/rs$$$$ || exit $(STOPOUT)

# Test that all stream files round-trip properly with compression
RULES_ROUNDTRIP_COMPRESS=$(patsubst %,roundtrip-compress-%,$(wildcard *.fi))
roundtrip-compress:
	@echo "=== Testing stream-file round-tripping with compression:" 
	@$(PARALLEL_MAKE) $(RULES_ROUNDTRIP_COMPRESS)

$(RULES_ROUNDTRIP_COMPRESS): roundtrip-compress-%: %
	@echo "  $<"; \
	$(REPOSURGEON) "$(TESTOPT)" "set compress" "read -;write -" \
		<$< >/tmp/rs$$$$ || exit $(STOPOUT); \
	[ -s /tmp/rs$$$$ ] && diff --text -u $< /tmp/rs$$$$ \
		|| exit $(STOPOUT); \
	rm -f /tmp/rs$$$$ || exit $(STOPOUT)

# Test that dumping metadata to msgbox form and updating from the message-box
# is idempotent if you make no changes to the message-box.
RULES_MESSAGE_BOX=$(patsubst %,messagebox-%,$(wildcard *.fi))
messagebox:
	@echo "=== Testing msgout/msgin roundtripping:"
	@$(PARALLEL_MAKE) $(RULES_ROUNDTRIP_COMPRESS)

$(RULES_MESSAGE_BOX): messagebox-%: %
	@echo "  $${file}";\
	$(REPOSURGEON) "$(TESTOPT)" "read <$<" "edit echo>/dev/null" "write -" \
	>/tmp/regress-a$$$$ || exit $(STOPOUT); \
	[ -s /tmp/regress-a$$$$ ] && diff --text -u $< /tmp/regress-a$$$$ \
	|| { rm -f /tmp/regress-a$$$$; exit $(STOPOUT); }; \
	rm -f /tmp/regress-a$$$$

# General regression testing of commands and output; look at the *.tst and
# corresponding *.chk files to see which tests this runs.
TESTLOADS := $(shell ls -1 *.tst | sed '/.tst/s///')
fi-buildregress: multigen.svn ignore.svn global-ignores.svn tagdoublet.svn 
	@for file in $(TESTLOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(REPOSURGEON) $(BUILDOPT) "$(TESTOPT)" "script $${file}.tst testing123" >$${file}.chk \
		2>&1 || exit $(STOPOUT); \
	done

fi-regress: multigen.svn ignore.svn global-ignores.svn ignore-copy.svn global-ignores-copy.svn mixedbranchlift.svn
	@echo "=== Running general tests:"
	@$(PARALLEL_MAKE) $(TESTLOADS:%=fi-regress-%)

# Generated test loads
multigen.svn: multigen.sh
	sh multigen.sh -d >multigen.svn
ignore.svn: ignoregen.sh
	sh ignoregen.sh ignore >ignore.svn
global-ignores.svn: ignoregen.sh
	sh ignoregen.sh global-ignores >global-ignores.svn
ignore-copy.svn: ignoregen.sh
	sh ignoregen.sh ignore copy >ignore-copy.svn
global-ignores-copy.svn: ignoregen.sh
	sh ignoregen.sh global-ignores copy >global-ignores-copy.svn
tagdoublet.svn: tagdoubletgen.sh
	sh tagdoubletgen.sh >tagdoublet.svn
mixedbranchlift.svn: branchliftgen.sh
	sh branchliftgen.sh >mixedbranchlift.svn

$(TESTLOADS:%=fi-regress-%): fi-regress-%: %.tst
	@file=$(<:.tst=); \
	( $(ECHO) -n "  $${file} "; grep --text '##' $${file}.tst  || echo ' ## (no description)' ) | sed -e '/ ##/s//:/' ; \
	    $(REPOSURGEON) "$(TESTOPT)" "script $${file}.tst testing123" >/tmp/regress-b$$$$ 2>&1 \
		|| (echo "*** Nonzero return status on $${file}!"; exit $(STOPOUT) ); \
	    diff --text -u $${file}.chk /tmp/regress-b$$$$ >/tmp/diff$$$$; \
	    case $$? in \
	    0) ;; \
	    1) if [ $(QUIET) = 1 ]; then echo FAILED; else cat /tmp/diff$$$$; fi; if [ $(STOPOUT) = 1 ]; then { rm -f /tmp/regress-b$$$$ .tmp/diff$$$$; exit 1; }; fi;; \
	    *) echo "*** diff had trouble, status $$?"; { rm -f /tmp/regress-b$$$$ /tmp/diff$$$$; exit $(STOPOUT); };; \
	    esac ; \
	rm -f /tmp/regress-b$$$$ /tmp/diff$$$$

# Test the git extractor
GITLOADS = bs
git-regress:
	@echo "=== Testing git-extractor:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
		$(PARALLEL_MAKE) $(GITLOADS:%=git-regress-test-%); \
	else echo "    Skipped, git missing."; exit 0; \
	fi

# Test the git extractor with multiple git branches
GITBRANCHES = be bb
git-regress-branches:
	@echo "=== Testing git-extractor with multiple git branches:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
		$(PARALLEL_MAKE) $(GITBRANCHES:%=git-regress-test-%); \
	else echo "    Skipped, git missing."; exit 0; \
	fi

# Test the git extractor with merges
GITMERGES = be2 be3 be4 be5 be6
git-regress-merges:
	@echo "=== Testing git-extractor with merges:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
		$(PARALLEL_MAKE) $(GITMERGES:%=git-regress-test-%); \
	else echo "    Skipped, git missing."; exit 0; \
	fi

# Test the git extractor with tags
GITTAGS = bt bt2 bt3
git-regress-tags:
	@echo "=== Testing git-extractor with tags:"
	@if command -v git >/dev/null 2>&1 ; \
	then \
		$(PARALLEL_MAKE) $(GITTAGS:%=git-regress-test-%); \
	else echo "    Skipped, git missing."; exit 0; \
	fi

RULES_GIT_REGRESS=$(patsubst %,git-regress-test-%, \
			$(GITLOADS) $(GITBRANCHES) $(GITTAGS) $(GITMERGES))

$(RULES_GIT_REGRESS): git-regress-test-%: %.fi
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	test=$(<:.fi=); \
		if (echo "  $${test}.fi" >&2; \
		./fi-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress-c$$$$; \
		then diff --text -u $${test}.fi /tmp/regress-c$$$$ || { rm -f /tmp/regress-c$$$$; exit $(STOPOUT); }; \
		else echo "*** Nonzero return status on $${test}!"; { rm -f /tmp/regress-c$$$$; exit $(STOPOUT); }; fi; \
	rm -f /tmp/regress-c$$$$


# Test the hg extractor
HGLOADS = testrepo2
hg-regress:
	@echo "=== Testing hg-extractor:"
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	if command -v hg >/dev/null 2>&1 && command -v git >/dev/null 2>&1 ; \
	then \
	    for test in $(HGLOADS); do \
		if (echo "  $${test}.fi" >&2; \
		./hg-to-fi) <$${test}.fi | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress-d$$$$; \
		then diff --text -u $${test}.fi /tmp/regress-d$$$$ || { rm -f /tmp/regress-d$$$$; exit $(STOPOUT); }; \
		else echo "*** Nonzero return status on $${test}!"; { rm -f /tmp/regress-d$$$$; exit $(STOPOUT); }; fi \
	    done; \
	else echo "    Skipped, hg or git missing."; exit 0; \
	fi; \
	rm -f /tmp/regress-d$$$$

# Test the hg extractor with multiple hg branches
# NOTE: the bb-alt test demonstrates an hg repo with coloring that git cannot reproduce
HGBRANCHES = be be2 be3 bb-alt be-bookmarks
hg-buildregress-branches:
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT; BUILDOPT=$(BUILDOPT); export BUILDOPT;\
	for file in $(HGBRANCHES); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit $(STOPOUT); \
	done
hg-regress-branches:
	@echo "=== Testing hg-extractor with multiple hg branches:"
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGBRANCHES); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress-e$$$$; \
		then diff --text -u $${test}.fi /tmp/regress-e$$$$ || { rm -f /tmp/regress-e$$$$; exit $(STOPOUT); }; \
		else echo "*** Nonzero return status on $${test}!"; { rm -f /tmp/regress-e$$$$; exit $(STOPOUT); }; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi; \
	rm -f /tmp/regress-e$$$$

# Test the hg extractor with merges
HGMERGES = be2 be3 be4 be5 be6
hg-buildregress-merges:
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	for file in $(HGMERGES); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit $(STOPOUT); \
	done
hg-regress-merges:
	@echo "=== Testing hg-extractor with merges:"
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT;\
	if command -v hg >/dev/null 2>&1 ; \
	then \
	    for test in $(HGMERGES); do \
		if (echo "  $${test}" >&2; \
		./hg-$${test}-test) | sed -e 1d -e '/^#legacy-id/d' >/tmp/regress-f$$$$; \
		then diff --text -u $${test}.fi /tmp/regress-f$$$$ || { rm -f /tmp/regress-f$$$$; exit $(STOPOUT); }; \
		else echo "*** Nonzero return status on $${test}!"; { rm -f /tmp/regress-f$$$$; exit $(STOPOUT); }; fi \
	    done; \
	else echo "    Skipped, hg missing."; exit 0; \
	fi; \
	rm -f /tmp/regress-f$$$$

# Test the hg extractor with tags
HGTAGS = bt bt2 bt3-hg bt3-hg-local
hg-buildregress-tags:
	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT; BUILDOPT=$(BUILDOPT); export BUILDOPT;\
	for file in $(HGTAGS); do \
	    echo "Remaking $${file}.fi"; \
	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
		2>&1 || exit $(STOPOUT); \
	done
hg-regress-tags:

=== debian/changelog ===
reposurgeon (4.24-1) unstable; urgency=medium

  * New upstream version 4.24
  * debian/control: Add new build-dependency on golang-github-xo-terminfo-dev
  * debian/rules: Generate surgeon/help-index.go before dh_auto_configure

 -- Anthony Fok <foka@debian.org>  Tue, 16 Feb 2021 07:32:49 -0700

reposurgeon (4.23-1) unstable; urgency=medium

  * New upstream version 4.23

 -- Anthony Fok <foka@debian.org>  Mon, 01 Feb 2021 04:09:58 -0700

reposurgeon (4.22-2) unstable; urgency=medium

  * Update local copy of yet-to-be-packaged dependent Go library:
    - gitlab.com/ianbruene/kommandant v0.6.1

 -- Anthony Fok <foka@debian.org>  Thu, 31 Dec 2020 18:05:48 -0700

reposurgeon (4.22-1) unstable; urgency=medium

  * New upstream version 4.22
  * Update package description according to upstream README.adoc.
    In particular, the DVCS Migration Guide has been merged into the
    long-form manual "Repository Editing and Conversion With Reposurgeon"
  * debian/control: Recommends cvs and subversion
    as suggested in the updated INSTALL.adoc
  * Add debian/patches/0001-Makefile-skip-build.patch and adjust debian/rules
    to allow building the reposurgeon binaries with dh-golang
    while buildling the documentation with upstream Makefile
  * Bump Standards-Version to 4.5.1 (no change)

 -- Anthony Fok <foka@debian.org>  Thu, 31 Dec 2020 16:14:39 -0700

reposurgeon (4.21-1) unstable; urgency=medium

  * New upstream version 4.21
    - Fix for a bug that could scramble history in pathological tag-copy cases.

 -- Anthony Fok <foka@debian.org>  Tue, 24 Nov 2020 00:44:03 -0700

reposurgeon (4.20-1) unstable; urgency=medium

  * New upstream version 4.20

 -- Anthony Fok <foka@debian.org>  Wed, 18 Nov 2020 02:20:13 -0700

reposurgeon (4.19-4) unstable; urgency=medium

  * Resume build on 32-bit architectures.
    Thanks to upstream author who enable compilation on 32-bit machines
    in commit 097b316 in the 4.17 release on 2020-08-16.
  * Add "-git restore '*.1'" to the execute_after_dh_auto_clean target
    so I don’t have to do it every time I run "gbp buildpackage"
  * Remove /usr/share/doc/reposurgeon/INSTALL.adoc to appease Lintian

 -- Anthony Fok <foka@debian.org>  Thu, 12 Nov 2020 12:22:55 -0700

reposurgeon (4.19-3) unstable; urgency=medium

  * Remove "make lint" test to prevent unpredicted FTBFS in the future.
    Special thanks to Paul Wise for the advice!  And indeed, 4.19-2 failed
    to build on ppc64 failed the golint test for pedantic reasons.
    Build-dependencies on golint and shellcheck are removed accordingly.
  * Remove debian/clean

 -- Anthony Fok <foka@debian.org>  Tue, 10 Nov 2020 15:18:22 -0700

reposurgeon (4.19-2) unstable; urgency=medium

  * Add Debian Go Team's debian/gitlab-ci.yml
  * Move debian/go/src to debian/go/_src so that "make lint" would not fail
  * Remove all Python related dependencies
    as reposurgeon is now written entirely in Go as of version 4.8
  * Run "make lint" and "make -C test" too,
    and add the shellcheck package as build-dependency
  * Update debian/copyright to include licenses of vendored libraries
  * Change repository to https://salsa.debian.org/go-team/packages/reposurgeon
    to be team-maintained with the Debian Go Packaging Team
    while I stay on as the main uploader
  * Bump debhelper dependency to "Build-Depends: debhelper-compat (= 13)"

 -- Anthony Fok <foka@debian.org>  Thu, 05 Nov 2020 16:29:01 -0700

reposurgeon (4.19-1) unstable; urgency=medium

  * New upstream version 4.19 (Closes: #973754)
  * Remove 0001-restore-missing-files.patch
  * Update local copies of yet-to-be-packaged dependent Go libraries:
    - github.com/ianbruene/go-difflib v1.2.0
    - github.com/termie/go-shutil v0.0.0-20140729215957-bcacb06fecae
    - gitlab.com/esr/fqme v0.1.0
    - gitlab.com/ianbruene/kommandant v0.6.0
  * Remove the following local copies which are already packaged for Debian:
    - github.com/chzyer/readline
    - github.com/kballard/go-shellquote
  * debian/control: Add new build-dependencies:
    - golang-github-chzyer-readline-dev (>= 1.4.39.g2972be2)
    - golang-github-kballard-go-shellquote-dev (>= 0.0~git20180428.95032a8)
  * debian/rules: Update to match upstream Makefile
  * Remove doc-base files for dvcs-migration-guide.html and reporting-bugs.html
    which are no longer distributed with the reposurgeon tarball

 -- Anthony Fok <foka@debian.org>  Thu, 05 Nov 2020 05:48:04 -0700

## reposurgeon 4.25

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,13 @@
 
 .PHONY: all fullinstall build stable-golang current-golang helpers test-helpers \
 		get test lint fmt clean install uninstall dist release refresh
+
+awk_supports_posix_arg = $(shell awk --posix "" >/dev/null 2>&1; echo $$?)
+ifeq ($(awk_supports_posix_arg), 0)
+AWK = awk --posix
+else
+AWK = awk
+endif
 
 # Binaries need to be built before generated documentation parts can be made.
 all: build $(MANPAGES) $(HTMLFILES)
@@ -58,10 +65,10 @@
 	go version
 
 helpers:
-	sudo apt-get install asciidoctor cvs-fast-export subversion cvs mercurial hg-git-fast-import rsync
+	sudo apt-get install asciidoctor awk
 
 test-helpers: 
-	sudo apt install golint shellcheck
+	sudo apt install cvs-fast-export subversion cvs mercurial hg-git-fast-import rsync golint shellcheck tappy
 
 #
 # Documentation
@@ -87,7 +94,6 @@
 	append \
 	authors \
 	assign \
-	bench \
 	blob \
 	branch \
 	branchlift \
@@ -163,7 +169,6 @@
 	timeoffset \
 	timequake \
 	timing \
-	tip \
 	transcode \
 	unassign \
 	undefine \
@@ -176,7 +181,9 @@
 	functions \
 	options \
 	redirection \
-	regexp
+	regexp \
+	selection \
+	syntax
 READ_OPTION_TOPICS = \
 	branchify
 TOPICS = $(BNF_TOPICS) $(UNANCHORED_TOPICS) $(READ_OPTION_TOPICS)
@@ -191,20 +198,13 @@
 	attribution \
 	lint \
 	profile \
-	reparent \
-	selection \
-	syntax
-
-# Most othe command descriptions in Repositpory editing are reposurgeon's embedded
+	reparent
+# Most of the command descriptions in Repositpory editing are reposurgeon's embedded
 # help, lightly massaged into asciidoc format.
 repository-editing.html: surgeon/reposurgeon.go reposurgeon repository-editing.adoc
 	@rm -fr docinclude; mkdir docinclude
 	@get_help() { \
-		./reposurgeon "set asciidoc" "help $${1}" | \
-			sed -e 's/help regexp/<<regular_expressions,help regexp>>/g' \
-			    -e 's/help read/<<read_cmd,help read>>/g' \
-			    -e 's/help branchify/<<branchify_opt,help branchify>>/g' \
-			    -e 's/#/+#+/'; \
+		./reposurgeon "set asciidoc" "help $${1}" | awk -f poundsign.awk; \
 	}; \
 	for topic in $(BNF_TOPICS); \
 	do \
@@ -237,7 +237,7 @@
 	@for topic in $(BNF_TOPICS); do head -2 "docinclude/$${topic}.adoc"; done | grep -v '^\[\[' | sed '/::$$/s///'
 
 surgeon/help-index.go: help-index.awk repository-editing.adoc
-	awk -f $^ >$@
+	$(AWK) -f $^ >$@
 
 #
 # Auxillary Go tooling productions
@@ -305,14 +305,14 @@
 # Code validation
 #
 
-check: lint build test
+check: lint all test
 	$(MAKE) -C test --quiet check BINDIR=$(realpath $(CURDIR))
 
 fixme:
 	@if command -v rg; then \
-		rg FIXME; \
+		rg --no-heading FIX''ME; \
 	else \
-		find . -type f -exec grep -n FIXME {} /dev/null \; | grep -v "[.]git"; \
+		find . -type f -exec grep -n FIX''ME {} /dev/null \; | grep -v "[.]git"; \
 	fi
 
 #

=== test/Makefile ===
# Test-suite makefile for reposurgeon

# Different implementations could be plugged in to the tests.
REPOSURGEON := reposurgeon 
REPOCUTTER := repocutter 
REPOTOOL := repotool
REPOMAPPER := repomapper

# Setting this to 1 suppresses detail sections in most TAP reportts.
QUIET=0

# The TAP filter. Only affects presentation of the test suite messages
TAPCONSUMER=tappy

# No user-serviceable parts below this line.

# Use absolute path so tests that change working directory still use 
# scripts from parent directory.  Note that using $PWD seems to fail
# here under Gitlab's CI environment.
PATH := $(BINDIR):$(realpath ..):$(realpath .):${PATH}

# Force the timezone in case CI has a different idea.
# Havoc ensues if this is not exported - not clear why.
export TZ=UTC

# Force pure serial execution when rebuilding check files.  Slower,
# but makes them deterministic and may help smoke out bugs in
# concurrent code.
BUILDOPT="set serial"

# See https://stackoverflow.com/questions/6481005/how-to-obtain-the-number-of-cpus-cores-in-linux-from-the-command-line
CONCURRENT_JOBS=$(shell getconf _NPROCESSORS_ONLN || getconf NPROCESSORS_ONLN || echo 4)

# Fall back to safety if our declared TAP consumer does not exist.
# This is helpful in the CI environment, where it wiuld be better for
# the logfiles to carry the raw TAP messages. 
TAPFILTER=$(shell command -v $(TAPCONSUMER) || echo cat)

# Run specified tests in parallel and ship their output to our TAP consumer after a plan header
TAPOUT = (echo "1..$(words $(1))"; $(MAKE) --output-sync --no-print-directory -j $(CONCURRENT_JOBS) $(1)) | $(TAPFILTER)

# Test whether we have a specified command
AVAILABLE=command -v $(1) >/dev/null 2>&1

# parallel-tap must not be run in parallel.
check:
	@$(MAKE) -j1 --no-print-directory parallel-tap

.SUFFIXES: .svn .chk .fi .map

.svn.chk:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@ 2>&1
.svn.fi:
	$(REPOSURGEON) "read <$<" "prefer git" "write -" >$@
.svn.map:
	$(REPOSURGEON) "log -all" "read <$<" "legacy write -" >$@

clean:
	@rm -fr .rs* test=repo test-checkout test-repo* test-checkout* git-repo left-repo right-repo *~

options:
	@echo "REPOSURGEON is '$(REPOSURGEON)'"
	@echo "TESTOPT is '$(TESTOPT)'"

# Show summary lines for all tests.
testlist:
	@grep --text '^##' *.tst *.sh
	@grep --text '^ ##' *.svn
listcheck:
	@for f in *.tst *.svn; do \
	    if ( head -3 $$f | grep --text -q '^ *##' ); then :; else echo "$$f needs a description" >&2; exit 1; fi;  \
	done

# BEGINS: Tests that require only reposurgeon itself

# Test that all stream files round-trip properly: compressed, uncompressed,
# and when passed through as message boxes by msgin/msgout.
RULES_ROUNDTRIP=$(patsubst %,roundtrip-%,$(wildcard *.fi))
ROUNDTRIP_COMPRESS_TARGETS=$(patsubst %,roundtrip-compress-%,$(wildcard *.fi))
MESSAGEBOX_TARGETS=$(patsubst %,messagebox-%,$(wildcard *.fi))

# Stream roundtripping tests
$(ROUNDTRIP_TARGETS): roundtrip-%: %
	@($(REPOSURGEON) "$(TESTOPT)" "read -; write -" <$< | tapdiffer "$< roundtrip" $<)
$(ROUNDTRIP_COMPRESS_TARGETS): roundtrip-compress-%: %
	@($(REPOSURGEON) "$(TESTOPT)" "set compress" "read -; write -" <$< | tapdiffer "$< compressed roundtrip" $<)
$(MESSAGEBOX_TARGETS): messagebox-%: %
	@$(REPOSURGEON) "$(TESTOPT)" "read <$<" "msgout >/tmp/msgbox$$$$" "msgin </tmp/msgbox$$$$" "write -" "shell rm /tmp/msgbox$$$$" | tapdiffer "$< message-box roundtripping" $<

# Generated command-test loads
multigen.svn: multigen.sh
	sh multigen.sh -d >multigen.svn
ignore.svn: ignoregen.sh
	sh ignoregen.sh ignore >ignore.svn
global-ignores.svn: ignoregen.sh
	sh ignoregen.sh global-ignores >global-ignores.svn
ignore-copy.svn: ignoregen.sh
	sh ignoregen.sh ignore copy >ignore-copy.svn
global-ignores-copy.svn: ignoregen.sh
	sh ignoregen.sh global-ignores copy >global-ignores-copy.svn
tagdoublet.svn: tagdoubletgen.sh
	sh tagdoubletgen.sh >tagdoublet.svn
mixedbranchlift.svn: branchliftgen.sh
	sh branchliftgen.sh >mixedbranchlift.svn

# General regression testing of commands and output; look at the *.tst and
# corresponding *.chk files to see which tests this runs.
COMMAND_LOADS := $(shell ls -1 *.tst | sed '/.tst/s///')
COMMAND_TARGETS=$(COMMAND_LOADS:%=command-regress-%)
$(COMMAND_TARGETS): command-regress-%: %.tst
	@singletest -a testing123 $<;
command-buildregress: multigen.svn ignore.svn global-ignores.svn tagdoublet.svn 
	@for file in $(COMMAND_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(REPOSURGEON) $(BUILDOPT) "$(TESTOPT)" "script $${file}.tst testing123" >$${file}.chk \
		2>&1 || exit 1; \
	done

# Regression-yest loading from Subversion
SVN_AND_TST_FILES := $(sort $(wildcard *.svn *.tst))
SVNLOAD_LOADS := $(shell echo $(SVN_AND_TST_FILES) | sed 's/\([^ ]*\)\.svn \1.tst//g; s/[^ ]*\.tst//g; s/\.svn//g')
svnload-buildregress:
	@for test in $(SVNLOAD_LOADS); do \
	    if [ -f $${test}.tst ] ; \
	    then \
		    echo "BUG: $${test} should have been skipped: $${test}.tst exists"; \
		    exit 1; \
		fi; \
		echo "Remaking $${test}.chk"; \
		rm -f $${test}.chk && $(MAKE) --quiet $${test}.chk || exit 1; \
	done
SVNLOAD_TARGETS=$(SVNLOAD_LOADS:%=svnload-regress-%)
$(SVNLOAD_TARGETS): svnload-regress-%: %.svn
	@test=$(<:.svn=); legend=$$(sed -n '/^ ## /s///p' <"$<" 2>/dev/null || echo "(no description)"); \
	$(REPOSURGEON) "$(TESTOPT)" "$(TESTOPT)" "read <$${test}.svn" "prefer git" "write -"  >/tmp/stream$$$$ 2>&1; \
	tapdiffer "$<: $${legend}" $${test}.chk </tmp/stream$$$$;

# Regression-testing of repocutter
REPOCUTTER_LOADS := $(shell ls -1 repocutter*.sh | sed '/.sh/s///')
repocutter-buildregress:
	@for file in $(REPOCUTTER_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(SHELL) $${file}.sh >$${file}.chk || exit 1; \
	done
REPOCUTTER_TARGETS = $(REPOCUTTER_LOADS:%=repocutter-test-%)
$(REPOCUTTER_TARGETS): repocutter-test-%:
	@legend=$$(sed -n '/^## /s///p' <"$*.sh" 2>/dev/null || echo "(no description)"); \
	$(SHELL) $*.sh | tapdiffer "$${legend}" $*.chk;

# Regression-testing of repomapper; look at the *.sh and
# corresponding *.chk files to see which tests this runs.
REPOMAPPER_LOADS := $(shell ls -1 repomapper*.sh | sed '/.sh/s///')
repomapper-buildregress:
	@for file in $(REPOMAPPER_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(SHELL) $${file}.sh >$${file}.chk || exit 1; \
	done
REPOMAPPER_TARGETS = $(REPOMAPPER_LOADS:%=mapper-test-%)
$(REPOMAPPER_TARGETS): mapper-test-%:
	@legend=$$(sed -n '/^## /s///p' <"$*.sh" 2>/dev/null || echo "(no description)"); \
	$(SHELL) $*.sh | tapdiffer "$${legend}" $*.chk;
repomapper-regress:
	@echo "=== Running repomapper tests:"
	@$(call TAPOUT,$(REPOMAPPER_TARGETS))

# Test legacy-map generation
LEGACY_LOADS=nut mergeinfo-with-split
legacy-buildregress:
	@for test in $(LEGACY_LOADS); \
	do \
	    echo "Remaking $${test}.map"; \
	    rm -f $${test}.map && $(MAKE) --quiet $${test}.map 2>/dev/null || exit 1; \
	done
LEGACY_TARGETS = $(LEGACY_LOADS:%=legacy-test-%)
$(LEGACY_TARGETS): legacy-test-%: %.svn
	@legend=$$(sed -n '/^ ## /s///p' <"$<" 2>/dev/null || echo "(no description)"); \
	$(REPOSURGEON) "$(TESTOPT)" "read <$<" "legacy write -" | grep -v '^reposurgeon:' 2>/dev/null \
	| tapdiffer "$${legend}" $(basename $<).map

# ENDS: Tests that require only reposurgeon itself

# BEGINS: Tests requiring svn but not git

ifneq ($(call AVAILABLE svn),)

# Regression-testing of Subversion permission-bit and other exceptional cases.
# These tests are actually here to check Subversion's behavior, in case something
# poorly documented changes.
SVNCHECK_LOADS := $(shell ls -1 svncheck*.sh | sed '/.sh/s///')
svncheck-buildregress:
	@for file in $(SVNCHECK_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(SHELL) $${file}.sh -d | $(REPOSURGEON) "$(TESTOPT)" "set testmode" 'read -' 'prefer git' 'write -' >$${file}.chk || exit 1; \
	done
SVNCHECK_TARGETS = $(SVNCHECK_LOADS:%=svncheck-test-%)
$(SVNCHECK_TARGETS): svncheck-test-%:
	@legend=$$(sed -n '/^## /s///p' <"$*.sh" 2>/dev/null || echo "(no description)"); \
	$(SHELL) $*.sh -d | $(REPOSURGEON) "$(TESTOPT)" "set testmode" 'read -' 'prefer git' 'write -' \
	| tapdiffer "$*: $${legend}" $*.chk;

endif # if svn

# ENDS: Tests requiring svn but not git

# All tests past this point reqire Git

ifneq ($(call AVAILABLE git),)

# BEGINS: Tests requiring svn and git

ifneq ($(call AVAILABLE svn),)

# Test Subversion conversion correctness
LIFTCHECK_LOADS = $(wildcard *.svn)
LIFTCHECK_TARGETS = $(LIFTCHECK_LOADS:%=liftcheck-regress-full-%)
$(LIFTCHECK_TARGETS): liftcheck-regress-full-%: %
	@liftcheck -q -r all $<

endif # if svn

# ENDS: Tests requiring svn and git

# BEGINS: Tests requiring git only

# Test the git extractor
GIT_EXTRACTOR_LOADS= bs.fi testrepo2.fi utf8.fi
GIT_EXTRACTOR_TARGETS = $(GIT_EXTRACTOR_LOADS:%=git-extractor-test-%)
$(GIT_EXTRACTOR_TARGETS): git-extractor-test-%: %
	@./fi-to-fi <$< | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon/d' \
	| tapdiffer "$<: git extractor round-tripping" $<;

# ENDS: Tests requiring git only

# BEGINS: Tests requiring hg

ifneq ($(call AVAILABLE hg),)

# Test the hg supprt
HGSTREAMS = testrepo2
HGSTREAMS_EXTRACTOR_TARGETS = $(HGSTREAMS:%=hg-extractor-test-%)
$(HGSTREAMS_EXTRACTOR_TARGETS): hg-extractor-test-%: %.fi
	@./hg-to-fi <$< | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon/d' \
	| tapdiffer "$<: hg extractor" $<;
HGSCRIPTS = $(subst -test,,$(subst hg-,,$(wildcard hg-*-test)))
hg-buildregress:
	@for item in $(HGSCRIPTS); do \
	    echo "Remaking $${item}.fi"; \
	    ./hg-$${item}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${item}.fi \
		2>&1 || exit 1; \
	done
HG_EXTRACTOR_TARGETS=$(HGSCRIPTS:%=hg-extractor-test-%)
$(HG_EXTRACTOR_TARGETS): hg-extractor-test-%: %.fi
	@./hg-$*-test | sed -e 1d -e '/^#legacy-id/d'  | sed -e '/^#reposurgeon/d' \
	| tapdiffer "$<: hg extractor round-tripping" $<

endif # if hg

# ENDS: Tests requiring hg

endif # if git

# Test past this point may depend on any VCS and are expected
# to die cleanly wuth a TAP complaint if they can't find what they need.

# Regression-testing of repotool; look at the *.sh and
# corresponding *.chk files to see which tests this runs.
REPOTOOL_LOADS := $(shell ls -1 repotool*.sh | sed '/.sh/s///')
repotool-buildregress:
	@for file in $(REPOTOOL_LOADS); do \
	    echo "Remaking $${file}.chk"; \
	    $(SHELL) $${file}.sh --rebuild || exit 1; \
	done
REPOTOOL_TARGETS = $(REPOTOOL_LOADS:%=repotool-test-%)
$(REPOTOOL_TARGETS): repotool-test-%:
	@legend=$$(sed -n '/^## /s///p' <"$*.sh" 2>/dev/null || echo "(no description)"); \
	$(SHELL) $*.sh --regress

# Miscellaneous tests.
SPORADIC_LOADS := hashcheck workflow-cvs-git workflow-svn-git
SPORADIC_TARGETS = $(SPORADIC_LOADS:%=sporadic-test-%)
$(SPORADIC_TARGETS): sporadic-test-%:
	@$(SHELL) $*.sh

# All test targets. Putting expensive targets early in this list might
# shave a little off total time. The Subversion tools are much the slowest
# so those tests start first.
TEST_TARGETS = $(LIFTCHECK_TARGETS) $(SVNCHECK_TARGETS) \
		$(GIT_EXTRACTOR_TARGETS) $(HGSTREAMS_EXTRACTOR_TARGETS) $(HG_EXTRACTOR_TARGETS) \
		$(ROUNDTRIP_TARGETS) $(ROUNDTRIP_COMPRESS_TARGETS) $(MESSAGEBOX_TARGETS) \
		$(COMMAND_TARGETS) $(SVNLOAD_TARGETS) $(LEGACY_TARGETS) \
		$(REPOMAPPER_TARGETS) $(REPOTOOL_TARGETS) $(REPOCUTTER_TARGETS) \
		$(SPORADIC_TARGETS)

# Here's how we actually run the tests:

# Issue a straight TAP report, no parallelism or filtering
tap: clean count $(TEST_TARGETS)
count:
	@echo 1..$(words $(TEST_TARGETS))

# This is the normal way to run the tests interactively,
# using a TAP consumer.
parallel-tap: clean disclose
	@$(call TAPOUT,$(TEST_TARGETS))

disclose:
	@echo "Running with $(CONCURRENT_JOBS) threads."

buildregress: command-buildregress svnload-buildregress legacy-buildregress \
	hg-buildregress repomapper-buildregress repotool-buildregress repocutter-buildregress \
	svncheck-buildregress 

# Test productions end here.

=== debian/changelog ===
reposurgeon (4.25-1) unstable; urgency=medium

  * New upstream version 4.25
  * Refresh debian/patches/0001-Makefile-skip-build.patch

 -- Anthony Fok <foka@debian.org>  Thu, 04 Mar 2021 19:56:10 -0700

=== debian/control ===
Source: reposurgeon
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Anthony Fok <foka@debian.org>
Section: vcs
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: asciidoctor,
               cvs,
               debhelper-compat (= 13),
               dh-golang,
               git,
               golang-any,
               golang-github-anmitsu-go-shlex-dev (>= 0.0~git20200514.38f4b40),
               golang-github-chzyer-readline-dev (>= 1.4.39.g2972be2),
               golang-github-emirpasic-gods-dev (>= 1.12.0),
               golang-github-kballard-go-shellquote-dev (>= 0.0~git20180428.95032a8),
               golang-github-xo-terminfo-dev (>= 0.0~git20210125.ca9a967),
               golang-golang-x-crypto-dev,
               golang-golang-x-text-dev,
               mercurial,
               subversion,
               time
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/go-team/packages/reposurgeon
Vcs-Git: https://salsa.debian.org/go-team/packages/reposurgeon.git
Homepage: http://www.catb.org/esr/reposurgeon/
Rules-Requires-Root: no
XS-Go-Import-Path: gitlab.com/esr/reposurgeon

Package: reposurgeon
Architecture: any
Depends: tzdata,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: cvs,
            cvs-fast-export,
            git,
            subversion
Suggests: brz,
          darcs,
          fossil,
          hg-fast-export
Built-Using: ${misc:Built-Using}
Description: Tool for editing version-control repository history
 `reposurgeon` enables risky operations that version-control systems
 don't want to let you do, such as (a) editing past comments and metadata,
 (b) excising commits, (c) coalescing commits, and (d) removing files and
 subtrees from repo history. The original motivation for `reposurgeon`
 was to clean up artifacts created by repository conversions.
 .
 `reposurgeon` is also useful for scripting very high-quality
 conversions from Subversion.  It is better than `git-svn` at tag
 lifting, automatically cleaning up `cvs2svn` conversion artifacts,
 dealing with nonstandard repository layouts, recognizing branch
 merges, handling mixed-branch commits, and generally at coping with
 Subversion's many odd corner cases.  Normally Subversion repos should
 be analyzed at a rate of upwards of ten thousand commits per minute,
 though that rate can fall significantly on extremely large
 repositories.
 .
 An auxiliary program, `repotool`, performs various useful
 operations such as checkouts and tag listing in a VCS-independent
 manner.  Yet another, `repomapper`, assists in automatically preparing
 contributor maps of CVS and SVN repositories.
 .
 The `repocutter` program is available for some specialized operations on
 Subversion dumpfiles; it may be useful in extracting portions of
 particularly gnarly Subversion repositories for conversion with
 reposurgeon.
 .
 This distribution supports a generic conversion workflow using these
 tools, and includes a long-form manual "Repository Editing and
 Conversion With Reposurgeon" that describes how to use it.
 .
 The file `reposurgeon-git-aliases` can be appended to your `~/.gitconfig` to
 support working directly with action stamps in git.
 .
 Finally, an Emacs Lisp mode with useful functions for editing large
 comment message-boxes is included.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_EXTRA := test

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with golang

execute_before_dh_auto_configure:
	$(MAKE) surgeon/help-index.go
	sh extractversion.sh -g <NEWS.adoc >surgeon/version.go

execute_after_dh_auto_configure:
	ln -s $(CURDIR)/debian/go/_src _build/src/gitlab.com/esr/reposurgeon/vendor

execute_after_dh_auto_build:
	for i in cutter mapper surgeon tool; do \
		cp -al _build/bin/$$i repo$$i ; \
		done
	$(MAKE)

override_dh_auto_install:
	DH_INTERNAL_OPTIONS= dh_auto_install -- prefix=/usr
	rm -f debian/reposurgeon/usr/share/doc/reposurgeon/INSTALL.adoc

execute_after_dh_auto_test:
	$(MAKE) -k -C test --quiet check BINDIR=$(realpath $(CURDIR))

execute_after_dh_auto_clean:
	DH_INTERNAL_OPTIONS= dh_auto_clean
	-git restore '*.1'
